Redmine - Defect #41515

Connection to mailserver is not properly terminated
2024-10-21 13:21 - Hendrik Jaeger

Status: Closed Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: Email notifications Estimated time: 0.00 hour

Target version:

Resolution: Fixed Affected version: 51.2

Description
Hi

Basic info first:

Environment:
Redmine version 5.1.2.stable
Ruby version 3.1.2-p20 (2022-04-12) [x86_64-linux—gnu]
Rails version 6.1.7.7
Environment production
Database adapter PostgreSQL
Mailer queue ActivedJob: :QueueAdapters: :AsyncAdapter
Mailer delivery smtp
Redmine settings:
Redmine theme Alternate
SCM:
Git 2.39.5
Filesystem

Redmine plugins:
no plugin installed

Postgres: 15.8-0+debl2ul

The problem I'm actually seeing is that sometimes some mails don't arrive.
| also noticed errors from my mailserver saying the following:

2024-10-21 10:01:51 [16088] 1t2pEO-0004BU-1Z SMTP connection lost after final dot H=wilhelm.netwic
htig.de (localhost.localdomain) [95.216.1.126]:37214 I=[213.133.111.59]:587 P=esmtpsa

For reference:

e 95.216.1.126 is wilhelm.netwichtig.de is the server where a VM runs in which redmine runs.
e 213.133.111.59 is leonardo.netwichtig.de where the mailserver runs that redmine is configured to use with AUTH to send
emails.

Exim says that the client did not properly close the SMTP connection but just abandoned it after the final dot, i.e. before exim could
acknowledge that it received the message completely, and therefore exim does not accept the message and the message is lost.

At the same time | see in redmine logs:

I, [2024-10-21T10:01:48.228979 #585774] INFO —- : [ActiveJob] [ActionMailer::MailDeliveryJob] [cf
534f2e-1f4a-48d5-a3d9-a60af7ed0052] Performed ActionMailer::MailDeliveryJob (Job ID: cfb534f2e-1f4a
-48d5-a3d9-a60af7ed0052) from Async (mailers) in 8286.05ms
I, [2024-10-21T10:01:48.761573 #585774] INFO —-- : [ActiveJob] [ActionMailer::MailDeliveryJob] [9e
ed43b3-8e56-4370-9372-468d0292c96f] Performed ActionMailer::MailDeliveryJob (Job ID: 9eed43b3-8e56
-4370-9372-468d0292c96f) from Async(mailers) in 8824.51lms

E, [2024-10-21T10:01:49.506526 #585774] ERROR -- : [ActiveJob] [ActionMailer::MailDeliveryJob] [4c
1324f7-b5a4-4£fd6-9a48-e232501b1631] Email delivery error: Net::ReadTimeout with #<Socket: (closed)>
I, [2024-10-21T10:01:49.506718 #585774] INFO —-- : [ActiveJob] [ActionMailer::MailDeliveryJob] [4c

1324£f7-b5a4-4£d6-9a48-e232501b1631] Performed ActionMailer::MailDeliveryJob (Job ID: 4cl324f7-b5a4
-4£d6-9a48-e232501b1631) from Async(mailers) in 9567.1l6ms
In this case it tried to notify 3 recipients who are involved with the ticket that was updated, hence three MailDeliveryJobs.

The relevant part is that it seems to timeout and just close the connection.

According to my research the default “read_timeout™ for the "Net” module might be 5 seconds, which is way too low for SMTP! The
RFC goes up to 5 minutes AFAIR and having delays of several seconds is not uncommon, e.g. for the reason that "at-SMTP-time"
spamscanning of emails can take a few seconds.

So my suggestion is to increase that timeout to at least 30s, or to be fully RFC-compliant, 5 minutes.

I am not 100% sure that | am interpreting the situation correctly, though, so feel free to correct me, request more information, etc.
My only goal here is to get the problem fixed ...

History

#1 - 2024-10-21 13:22 - Hendrik Jaeger

Yet again, | forgot to preview before posting. Sorry for the broken formatting. | don’t see a way to edit the description afterwards, as | do in my
redmine. Please let me know if there is any way to fix it and | will.

#2 - 2024-10-21 13:54 - Hendrik Jaeger

In https://guides.rubyonrails.org/action_mailer_basics.html#action-mailer-configuration | found that | can just add

read_timeout: 300
in configuration.yml and that seems to fix the issue.
This should be made the default.

#3 - 2024-10-21 14:12 - Holger Just

- Description updated

#4 - 2024-10-21 14:23 - Holger Just
- Status changed from New to Closed

- Resolution set to Fixed

The default read timeout is 5 seconds which | believe is reasonable for most setups. Setting this to a higher value may be required for special setups
where the mailserver is either rather slow or performs heavy processing on the sent mail before accepting it, both of which is rather rare in common
setups. A very long timeout of 5 minutes however may also mask intermediate issues and could result in overflowing queues.

As such, | think the default value is still reasonable for most setups and should not be changed. However, | saw that you already added some
documentation to EmailConfiguration which will help others who may run into your issue. As such, I'm going to close this issue as Fixed with the
documentation update.

Thank you for your contribution!
https://guides.rubyonrails.org/action_mailer_basics.html#action-mailer-configuration
https://www.redmine.org/projects/redmine/wiki/EmailConfiguration#Email-delivery-error-NetReadTimeout-with-ltSocketclosedgt
http://www.tcpdf.org

